//
//  main.m
//  TSRecoverHandlerHelp
//
//  Created by IB4 on 6/24/14.
//  Copyright (c) 2014 IBURD4. All rights reserved.
//

#include <syslog.h>
#include <xpc/xpc.h>
#include "XpcUtility.h"

int main(int argc, const char *argv[]) {
    NSLog(@"Recover Helper Start!");
    syslog(LOG_NOTICE, "RecoveryHelper v1.1 is running");
    NSDictionary *infoDict = [[NSBundle mainBundle] infoDictionary];
    NSString *appVersion = [infoDict objectForKey:@"CFBundleVersion"];
    NSLog( @"Recover Handler Help, appVersion: %@", appVersion );
    
    xpc_connection_t service = xpc_connection_create_mach_service("com.transcend.TSRecoverHandlerHelp",
                                                                  dispatch_get_main_queue(),
                                                                  XPC_CONNECTION_MACH_SERVICE_LISTENER);
    
    if (!service) {
        syslog(LOG_NOTICE, "Failed to create RecoveryHelper service.");
        exit(EXIT_FAILURE);
    }
    
    syslog(LOG_NOTICE, "Configuring connection event handler for TSRecoverHandlerHelp");
    xpc_connection_set_event_handler(service, ^(xpc_object_t connection) {
        __XPC_Connection_Handler(connection);
    });
    
    xpc_connection_resume(service);
    
    dispatch_main();
    
    xpc_release(service);
    
    return EXIT_SUCCESS;
}

